from ....dbsignal.SignalUtilities import SignalUtilities
from ....dbsignal.Signal import Signal


class IqdsQuery(object):

    @staticmethod
    def query_synchronize_pm_signal(metadata, SIGNAL_NAME, timestamp, source=None):
        SIGNAL_NAME = SIGNAL_NAME if type(SIGNAL_NAME) is list else [SIGNAL_NAME]
        source = metadata['source'] if source == None else source

        pm_signal = Signal()
        for SIGNAL_NAME_el in SIGNAL_NAME:
            pm_signal.read('pm', append=True, system=metadata['system'], className=metadata['className'], source=source,
                           signalName=SIGNAL_NAME_el, eventTime=timestamp)

        # Preprocess signal
        pm_df = pm_signal.getSynchronizedTimeDataframe(timestamp)
        return SignalUtilities.convertIndicesToSeconds(pm_df)
